<template>
  <div class="auth-v1">
    <b-row class="m-0 p-0">
      <!-- Login v1 -->
      <b-col lg="8" class="p-0">
        <div
          :style="{ 'background-image': 'url(' + bgImgOne + ')' }"
          class="login-bg"
        ></div>
      </b-col>
      <b-col lg="4" class="d-flex align-items-center auth-bg login-card">
        <div
          class="auth-wrapper auth-v1"
          :style="{ 'background-image': 'url(' + bgImg + ')' }"
        >
          <div class="auth-inner p-0">
            <span class="brand-logo">
              <b-img :src="appLogoImage" alt="logo" class="brand-main-logo" />
            </span>
            <!-- Login v1 -->
            <b-card class="mb-0 login-card" id="loginCard" v-show="isLoginCard">
              <h1 class="login-header">
                <span @click="resetPage()" v-if="loginWithPassword || loginWithOtp"
                  ><IconBackHome class="login-back-btn"></IconBackHome
                ></span>
                <span>Welcome</span>
                <p>User !</p>
              </h1>
              <p class="login-desc">
                Please enter your email id and password/otp details to access your
                account.
              </p>
              <!-- form -->

              <Form @submit="login" v-slot="{ meta }" :validation-schema="schema">
                <!-- email -->

                <b-form-group label-for="login-email">
                  <TextInput
                    v-if="!loginWithPassword && !loginWithOtp"
                    name="email"
                    label="Email ID"
                    type="email"
                    placeholder="Enter Email ID"
                    :value="userEmail"
                    :maxLength="50"
                    :autofocus="true"
                    @change="changedEmail"
                  ></TextInput>

                  <!-- <b-form-input class="text-transform-none" v-model="userEmail"
                        :state="errors.email && errors.email.length > 0 ? false : null" placeholder="Enter Email ID"
                        v-if="!loginWithPassword && !loginWithOtp" autofocus maxlength="50" />
                        <small v-if="errors.email" class="text-danger">{{ errors.email }}</small> -->

                  <label class="d-block" v-if="loginWithPassword || loginWithOtp">Email ID</label>
                  <b-form-input
                    class="text-transform-none"
                    v-model="userEmail"
                    v-if="loginWithPassword || loginWithOtp"
                    readonly
                    disabled
                  />
                  <small class="text-danger">{{}}</small>
                  <small class="text-danger" v-if="errorMessageBlock == true"
                    >This user is still not activated. Please
                    <b-link class="text-underline" @click="sendActivationLink()">
                      <small>Click Here</small>
                    </b-link>
                    to get activation link.</small
                  >
                </b-form-group>

                <!-- forgot password -->
                <b-form-group v-if="loginWithPassword" class="login-password-group">
                  <PasswordInput
                    ref="loginPassword"
                    name="password"
                    label="Password"
                    placeholder="Enter Password"
                    :value="password"
                    :maxlength="50"
                    :autofocus="true"
                  ></PasswordInput>
                  <b-link
                    class="forgot-password"
                    :to="{ name: 'forgot-password', query: { mail: this.userEmail } }"
                  >
                    <small>Forgot Password?</small>
                  </b-link>
                </b-form-group>

                <template v-if="loginWithOtp">
                  <p class="verification-label">Enter Verification Code</p>
                  <b-form-group label-for="otp" class="otp-box">
                    <div class="d-flex gap-2">
                      <b-form-input
                        class="otp-input"
                        ref="loginOtpOne"
                        v-model="loginOtpOne"
                        id="otp"
                        name="otp1"
                        maxlength="1"
                        @keydown="otpInputDown(1, $event)"
                        @input="otpInput(1, $event)"
                        v-on:keypress="isNumber($event)"
                      />
                      <b-form-input
                        class="otp-input"
                        ref="loginOtpTwo"
                        v-model="loginOtpTwo"
                        id="otp"
                        name="otp2"
                        maxlength="1"
                        @keydown="otpInputDown(2, $event)"
                        @input="otpInput(2, $event)"
                        v-on:keypress="isNumber($event)"
                      />
                      <b-form-input
                        class="otp-input"
                        ref="loginOtpThree"
                        v-model="loginOtpThree"
                        id="otp"
                        name="otp3"
                        maxlength="1"
                        @keydown="otpInputDown(3, $event)"
                        @input="otpInput(3, $event)"
                        v-on:keypress="isNumber($event)"
                      />
                      <b-form-input
                        class="otp-input"
                        ref="loginOtpFour"
                        v-model="loginOtpFour"
                        id="otp"
                        name="otp4"
                        maxlength="1"
                        @keydown="otpInputDown(4, $event)"
                        @input="otpInput(4, $event)"
                        v-on:keypress="isNumber($event)"
                      />
                    </div>
                  </b-form-group>

                  <p class="coundown-label" v-if="0 < countDown">
                    <small>
                      <IconOtpSend class="sms-icon" />Resend Verification Code<span
                        class="sms-time"
                        >(00:{{ time }})</span
                      ></small
                    >
                  </p>
                  <p class="coundown-label-link" v-if="countDown < 1">
                    <b-link @click="resetOtp">
                      <small>
                        <IconOtpResend class="sms-icon" />Resend Verification Code</small
                      >
                    </b-link>
                  </p>
                </template>
                <center>
                  <b-button
                    type="submit"
                    variant="primary"
                    class="login-btn btn-block"
                    block
                    v-if="!loginWithOtp"
                  >
                    <span v-if="loginWithPassword"> Login</span>
                    <span v-else> Next</span>
                  </b-button>
                  <!-- <b-button variant="secondary" :disabled="!meta.valid" class="login-btn mute-btn btn-block" block 
                      @click="formValidate()">
                      <span v-if="loginWithPassword"> Login</span>
                      <span v-else> Next</span>
                    </b-button> -->
                </center>
              </Form>
            </b-card>
            <div v-if="loginWithPassword || loginWithOtp">
              <div v-if="successMessage != ''" class="success-msg-block mt-3">
                <b-img :src="successIcon" size="15" />
                <p class="success-msg">{{ successMessage }}</p>
              </div>
            </div>
          </div>
        </div>
      </b-col>
      <!-- /Login v1 -->
    </b-row>
  </div>
</template>

<script>
import {
  BRow,
  BImg,
  BCol,
  BButton,
  BForm,
  BFormInput,
  BFormGroup,
  BCard,
  BLink,
  BCardTitle,
  BCardText,
  BInputGroup,
  BInputGroupAppend,
  BFormCheckbox,
  BAlert,
  BSpinner,
} from "bootstrap-vue";
import Auth from "@/apis/Auth";
import VuexyLogo from "@core/layouts/components/Logo.vue";
import { togglePasswordVisibility } from "@core/mixins/ui/forms";
import { getHomeRouteForLoggedInUser } from "@/auth/utils";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import axios from "axios";
axios.defaults.withCredentials = true;
import { makereq } from "@/common/api";
import { $themeConfig } from "@themeConfig";
import { useToast } from "vue-toastification";
const toast = useToast();
import DeviceDetector from "device-detector-js";
import * as yup from "yup";
import ability from "./../../../libs/acl/ability";
import { Form, Field, ErrorMessage, useForm } from "vee-validate";
export default {
  components: {
    // BSV
    Form,
    BRow,
    Form,
    Field,
    ErrorMessage,
    BImg,
    BCol,
    BButton,
    BForm,
    BFormInput,
    BFormGroup,
    BCard,
    BCardTitle,
    BLink,
    VuexyLogo,
    BCardText,
    BInputGroup,
    BInputGroupAppend,
    BFormCheckbox,
    BAlert,
    BSpinner,
  },
  mixins: [togglePasswordVisibility],

  data() {
    const {
      appVersion,
      successIcon,
      appLogoImage,
      bgImgOne,
      appBodyBG,
    } = $themeConfig.app;

    return {
      refs2: {
        loginForm: {
          validate: () => {
            return new Promise((resolve) => {
              resolve(true);
            });
          },
        },
      },
      errors: {},
      appVersion,
      appLogoImage,
      bgImgOne,
      bgImg: appBodyBG,
      isLoginClicked: false,
      isOtpClicked: false,
      successIcon,
      isSuccess: false,
      successMessage: "",
      loginWithPassword: false,
      loginWithOtp: false,
      userEmail: "",
      password: "",
      otp: "",
      isLoginCard: true,
      isOtpCard: false,
      isResendOtpLink: true,
      errorMessageBlock: false,
      isBtnEnabled: true,
      loginOtpOne: "",
      loginOtpTwo: "",
      loginOtpThree: "",
      loginOtpFour: "",
      countDown: 30,
      time: "30",
      latitude: "",
      longitude: "",
    };
  },
  computed: {
    passwordToggleIcon() {
      return this.passwordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
    schema() {
      return this.loginWithPassword
        ? yup.object({
            email: yup.string(),
            password: yup.string().required("Please enter Password"),
          })
        : yup.object({
            email: yup
              .string()
              .required("Please enter Email ID")
              .email("Please enter valid Email ID"),
            password: yup.string(),
          });
    },
  },
  mounted() {
    const appLoading = document.getElementById("loading-bg");
    if (appLoading) {
      appLoading.style.display = "none";
    }
    if ("geolocation" in navigator) {
      navigator.permissions.query({ name: "geolocation" }).then((permissionStatus) => {
        if (permissionStatus.state === "granted") {
          this.getCurrentLocation();
        } else if (permissionStatus.state === "prompt") {
          let that = this;
          navigator.geolocation.getCurrentPosition(
            function (position) {
              that.latitude = position.coords.latitude;
              that.longitude = position.coords.longitude;
            },
            function (error) {
              console.error("Error getting location:", error);
            }
          );
        }
      });
    }
  },
  methods: {
    changedEmail(e) {
      this.userEmail = e;
    },
    getCurrentLocation() {
      let that = this;
      navigator.geolocation.getCurrentPosition(function (position) {
        that.latitude = position.coords.latitude;
        that.longitude = position.coords.longitude;
      });
    },
    formValidate() {
      return true;
      // this.refs2.loginForm.validate();
    },
    otpInputDown(input, e) {
      if (e.key === "Backspace" || e.key === "Delete") {
        if (input == 2) {
          if (e.target.value == "") {
            this.$refs.loginOtpOne.focus();
          }
        }
        if (input == 3) {
          if (e.target.value == "") {
            this.$refs.loginOtpTwo.focus();
          }
        }
        if (input == 4) {
          if (e.target.value == "") {
            this.$refs.loginOtpThree.focus();
          }
        }
      }
    },
    otpInput(input, e) {
      if (input == 1) {
        if (e != "") {
          setTimeout(() => {
            this.$refs.loginOtpTwo.focus();
          }, 100);
        }
      }
      if (input == 2) {
        if (e != "") {
          this.$refs.loginOtpThree.focus();
        }
      }
      if (input == 3) {
        if (e != "") {
          this.$refs.loginOtpFour.focus();
        }
      }
      if (input == 4) {
        if (e != "") {
          if (
            this.loginOtpOne != "" &&
            this.loginOtpTwo != "" &&
            this.loginOtpThree != "" &&
            this.loginOtpFour != ""
          ) {
            this.login();
          }
        }
      }
    },
    validateEmail(email) {
      return email.match(
        /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
      );
    },
    countDownTimer() {
      if (this.countDown > 0) {
        setTimeout(() => {
          this.countDown -= 1;
          if (this.countDown.toString().length > 1) {
            this.time = this.countDown;
          } else {
            this.time = "0" + this.countDown;
          }
          this.countDownTimer();
        }, 1000);
      }
    },
    resetPage() {
      this.loginWithPassword = false;
      this.loginWithOtp = false;
      this.password = "";
      this.isLoginCard = true;
      this.isOtpCard = false;
      this.isSuccess = false;
    },
    async sendActivationLink() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      await makereq("/api/send-password-email", "post", {
        email: this.userEmail,
      })
        .then((response) => {
          appLoading.style.display = "none";
          if (response.data.status == true) {
            this.errorMessageBlock = false;
            toast({
              component: ToastificationContent,
              props: {
                title: "Success",
                icon: "CheckCircleIcon",
                text: response.data.message,
                variant: "success",
              },
            });
          } else {
            toast({
              component: ToastificationContent,
              props: {
                title: "Error",
                icon: "AlertCircleIcon",
                text: response.data.message,
                variant: "danger",
              },
            });
          }
        })
        .catch((error) => {
          toast({
            component: ToastificationContent,
            props: {
              title: "Error",
              icon: "AlertCircleIcon",
              text: "Something went wrong. Please try later.",
              variant: "danger",
            },
          });
          appLoading.style.display = "none";
        });
    },
    async login(values = null) {
      this.isSuccess = false;
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      this.isLoginClicked = true;
      // this.refs2.loginForm.validate().then(async (success) => {
      if (true) {
        const deviceDetector = new DeviceDetector();
        const userAgent = window.navigator.userAgent;
        const device = deviceDetector.parse(userAgent);
        const os = device.os.name ? device.os.name : "";
        const version = device.os.version ? device.os.version : "";
        if (this.loginWithPassword) {
          this.successMessage = "";
          Auth.loginWithPassword({
            email: values?.email || this.userEmail,
            password: values?.password || this.password,
            login_type: "web",
            device: device.device.type,
            os_version: os + " " + version,
            app_version: this.appVersion,
            latitude: this.latitude,
            longitude: this.longitude,
          })
            .then((response) => {
              const data = response.data;
              const result = data.result;
              if (data.status == true) {
                appLoading.style.display = "none";
                const userData = result.user;
                Auth.setToken(result.accessToken);
                localStorage.setItem("userData", JSON.stringify(userData));
                this.$ability.update(userData.permissions);
                ability.update(userData.permissions);
                setTimeout(() => {
                  this.$router.replace(getHomeRouteForLoggedInUser("admin")).then(() => {
                    // toast.success(data.title);
                  });
                }, 500);
                this.isLoginClicked = false;
              } else {
                toast({
                  component: ToastificationContent,
                  props: {
                    title: "Error",
                    icon: "AlertCircleIcon",
                    text: data.message,
                    variant: "danger",
                  },
                });

                this.isLoginClicked = false;
                appLoading.style.display = "none";
              }
            })
            .catch(() => {
              toast({
                component: ToastificationContent,
                props: {
                  title: "Error",
                  icon: "AlertCircleIcon",
                  text: "Something went wrong. Please try later.",
                  variant: "danger",
                },
              });
              this.isLoginClicked = false;
              appLoading.style.display = "none";
            });
        } else if (this.loginWithOtp) {
          this.otp =
            this.loginOtpOne + this.loginOtpTwo + this.loginOtpThree + this.loginOtpFour;
          Auth.verifyOtp({
            email: values?.email || this.userEmail,
            otp: this.otp,
            login_type: "web",
            device: device.device.type,
            os_version: os + " " + version,
            app_version: this.appVersion,
            latitude: this.latitude,
            longitude: this.longitude,
          })
            .then((response) => {
              const data = response.data;
              const result = data.result;
              if (data.status == true) {
                const userData = result.user;
                Auth.setToken(result.accessToken);
                localStorage.setItem("userData", JSON.stringify(userData));
                this.$ability.update(userData.permissions);
                ability.update(userData.permissions);
                this.isSuccess = false;
                this.$router.replace(getHomeRouteForLoggedInUser("admin")).then(() => {});
                this.isOtpClicked = false;
                this.isLoginClicked = false;
                appLoading.style.display = "none";
                this.successMessage = "";
              } else {
                toast({
                  component: ToastificationContent,
                  props: {
                    variant: "danger",
                    icon: "AlertCircleIcon",
                    title: data.title,
                    text: data.message,
                  },
                });

                this.isOtpClicked = false;
                this.isLoginClicked = false;
                appLoading.style.display = "none";
              }
            })
            .catch(() => {
              toast({
                component: ToastificationContent,
                props: {
                  title: "Error",
                  icon: "AlertCircleIcon",
                  text: "Something went wrong. Please try later.",
                  variant: "danger",
                },
              });
              this.isOtpClicked = false;
              this.isLoginClicked = false;
              appLoading.style.display = "none";
            });
        } else {
          this.successMessage = "";
          await Auth.login({
            email: values?.email || this.userEmail,
            login_type: "web",
          })
            .then((response) => {
              const data = response.data;
              const result = data.result;
              if (data.status == true) {
                this.errorMessageBlock = false;
                this.isLoginClicked = false;
                if (result.is_password == true) {
                  this.loginWithPassword = true;
                  this.loginWithOtp = false;
                  this.isBtnEnabled = true;
                }
                if (result.is_otp == true) {
                  this.loginWithPassword = false;
                  this.loginWithOtp = true;
                  this.isSuccess = true;
                  this.successMessage = data.message;
                }
                appLoading.style.display = "none";
              } else {
                if (data.title == "password_not_set") {
                  this.errorMessageBlock = true;
                } else {
                  toast({
                    component: ToastificationContent,
                    props: {
                      variant: "danger",
                      icon: "AlertCircleIcon",
                      title: data.title,
                      text: data.message,
                    },
                  });
                }
                this.isLoginClicked = false;
                appLoading.style.display = "none";
              }
            })
            .catch((error) => {
              toast({
                component: ToastificationContent,
                props: {
                  title: "Error",
                  icon: "AlertCircleIcon",
                  text: "Something went wrong. Please try later.",
                  variant: "danger",
                },
              });
              this.isLoginClicked = false;
              appLoading.style.display = "none";
            });
          if (this.loginWithPassword) {
            this.$refs.loginPassword.$refs.input.focus();
          }
          if (this.loginWithOtp) {
            this.$refs.loginOtpOne.focus();
            this.countDown = 30;
            this.time = "30";
            this.loginOtpOne = "";
            this.loginOtpTwo = "";
            this.loginOtpThree = "";
            this.loginOtpFour = "";
            this.countDownTimer();
          }
        }
      } else {
        this.isLoginClicked = false;
      }
      // });
    },
    verifyOtp() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      this.isOtpClicked = true;
      if (true) {
        Auth.verifyOtp({
          email: this.userEmail,
          otp: this.otp,
        })
          .then((response) => {
            const data = response.data;
            const result = data.result;
            if (data.status == true) {
              const userData = result.user;
              Auth.setToken(result.accessToken);
              localStorage.setItem("userData", JSON.stringify(userData));
              this.$ability.update(userData.permissions);
              ability.update(userData.permissions);
              this.$router.replace(getHomeRouteForLoggedInUser("admin")).then(() => {
                this.$toast({
                  component: ToastificationContent,
                  props: {
                    variant: "success",
                    icon: "CheckCircleIcon",
                    title: data.title,
                    text: data.message,
                  },
                });
              });
              this.isOtpClicked = false;
              appLoading.style.display = "none";
            } else {
              this.$toast({
                component: ToastificationContent,
                props: {
                  variant: "danger",
                  icon: "CheckCircleIcon",
                  title: data.title,
                  text: data.message,
                },
              });

              this.isOtpClicked = false;
              appLoading.style.display = "none";
            }
          })
          .catch(() => {
            this.$toast({
              component: ToastificationContent,
              props: {
                title: "Error",
                icon: "AlertCircleIcon",
                text: "Something went wrong. Please try later.",
                variant: "danger",
              },
            });
            this.isOtpClicked = false;
            appLoading.style.display = "none";
          });
      }
    },
    isNumber(e) {
      let char = String.fromCharCode(e.keyCode); // Get the character
      if (/^[0-9]+$/.test(char)) return true;
      // Match with regex
      else e.preventDefault(); // If not match, don't add to input text
    },
    resetOtp() {
      this.successMessage = "";
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      this.isResendOtpLink = false;
      Auth.sendOtp({
        email: this.userEmail,
        resend: true,
      })
        .then((response) => {
          const data = response.data;
          this.isSuccess = true;
          this.successMessage = data.message;
          this.countDown = 30;
          this.time = "30";
          this.countDownTimer();
          this.loginOtpOne = "";
          this.loginOtpTwo = "";
          this.loginOtpThree = "";
          this.loginOtpFour = "";
          this.$refs.loginOtpOne.focus();
          appLoading.style.display = "none";
          this.isResendOtpLink = true;
          this.$toast({
            component: ToastificationContent,
            props: {
              variant: "success",
              icon: "CheckCircleIcon",
              title: data.title,
              text: data.message,
            },
          });
        })
        .catch((error) => {
          this.$toast({
            component: ToastificationContent,
            props: {
              title: "Error",
              icon: "AlertCircleIcon",
              text: "Something went wrong. Please try later.",
              variant: "danger",
            },
          });
          this.isLoginClicked = false;
          this.isResendOtpLink = true;
          appLoading.style.display = "none";
        });
    },
  },
};
</script>

<style lang="scss">
@import "../../../scss/base/pages/page-auth.scss";
.input-group {
  .is-invalid {
    margin-bottom: -20px;
  }
}
.auth-v1 {
  .login-bg {
    height: 100%;
    background-size: cover;
  }
  .auth-inner {
  }
}
.brand-logo {
  display: flex;
  justify-content: center;
}
</style>
